# NOTE: Derived from blib/lib/Lemonldap/NG/Manager/Help.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Lemonldap::NG::Manager::Help;

#line 516 "blib/lib/Lemonldap/NG/Manager/Help.pm (autosplit into blib/lib/auto/Lemonldap/NG/Manager/Help/help_virtualHosts_fr.al)"
sub help_virtualHosts_fr {
    print <<EOT;
<h3>H&ocirc;tes virtuels</h3>

<p> La configuration d'un h&ocirc;te virtuel est divis&eacute;e en 2
parties&nbsp;: les r&egrave;gles et les en-t&ecirc;tes HTTP export&eacute;s.</p>

<p> <u>Note</u> : pour que le m&eacute;canisme d'authentification fonctionne,
tous les h&ocirc;tes virtuels et le portail doivent se trouver dans le domaine
d&eacute;clar&eacute; dans les param&egrave;tres g&eacute;n&eacute;raux ou
<u>utiliser les modules CDA</u> <i>(Cross-Domain-Authentication)</i> qui
g&egrave;re la transmission de l'identifiant.</p>

<h4> R&egrave;gles</h4>

<p>Une r&egrave;gle associe une expression r&eacute;guli&egrave;re perl
&agrave; une expression bool&eacute;enne. Lors de l'acc&egrave;s d'un
utilisateur, si l'URL demand&eacute;e correspond &agrave; la r&egrave;gle, le
droit d'acc&egrave;s est calcul&eacute; par l'expression bool&eacute;enne.
Exemple&nbsp;:</p>

<pre>
  # H&ocirc;te virtuel test.example.com - r&egrave;gles
  ^/protected =&gt; \$groups =~ /\\bgroup1\\b/
</pre>

<p> La r&egrave;gle ci-dessus signifie que pour les URL commen&ccedil;ant par
'/protected', les utilisateurs doivent appartenir au groupe 'group1'. Vous
pouvez &eacute;galement utiliser les mots-clefs 'accept' et 'deny'. Attention,
'accept' signifie que tous les utilisateurs authentifi&eacute;s peuvent
acc&eacute;der.</p>

<p>Si l'URL demand&eacute;e ne correspond &agrave; aucune des expressions
r&eacute;guli&egrave;res, le droit d'acc&egrave;s est calcul&eacute; &agrave;
partir de l'expression bool&eacute;enne d&eacute;finie dans la r&egrave;gle par
d&eacute;faut (default).</p>

<h5> Logout </h5>

Vous pouvez &eacute;galement &eacute;crire des r&egrave;gles pour intercepter
les URL de d&eacute;connexions des applications en utilisant les
mots-clefs&nbsp;:
<ul>
 <li>logout_sso URL : la requ&ecirc;te entraine une redirection vers le portail
  avec l'appel au syst&egrave;me de d&eacute;loguage. La requ&ecirc;te n'est
  pas transmise &agrave; l'applicationthe. Apr&egrave;s d&eacute;loguage,
  l'utilisateur est renvoy&eacute; vers l'URL,</li>
 <li>logout_app URL (Apache-2.x seulement) : la requ&ecirc;te est transmise
  &agrave; l'applications mais le r&eacute;sultat n'est pas
  affich&eacute;&nbsp;: l'utilisateur est redirig&eacute; vers l'URL,</li>
 <li>logout_app_sso URL (Apache-2.x seulement) : la requ&ecirc;te est transmise
  &agrave; l'application et ensuite, l'utilisateur est redirig&eacute; vers le
  portail avec appel au syst&egrave;me de d&eacute;loguage. Il est ensuite
  redirig&eacute; vers l'URL.</li>
</ul>

<h4> En-t&ecirc;tes</h4>

<p> Les en-t&ecirc;tes servant &agrave; l'application &agrave; savoir qui est
connect&eacute; se d&eacute;clarent comme suit&nbsp;: <tt>&lt;nom de
l'en-t&ecirc;te&gt; =&gt; &lt;expression Perl&gt;.
</p>

<p> Exemples :</p>

<pre>
  Auth-User =&gt; \$uid
  Unite     =&gt; \$departmentUID
</pre>
EOT
}

# end of Lemonldap::NG::Manager::Help::help_virtualHosts_fr
1;
